#include <windows.h>
#include "CommPort.h"

static HANDLE idComDev = 0;
static int port = 0;
__declspec(dllexport) /*boolean*/ long CommPort_open(struct HCommPort *myComm, long portId)
{
	char cbuf[10];
	COMMTIMEOUTS CommTimeOuts;
	port = portId;
	sprintf( cbuf, "COM%d:", port );
	printf( "Create file '%s'\n", cbuf );
	idComDev = CreateFile( cbuf, GENERIC_READ | GENERIC_WRITE, 
		0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( idComDev == NULL ) {
		printf( "CreateFile failed\n" );
		return( 0 );
	} else {
		printf( "CreateFile succeeded\n" );

		// set up buffers
		if ( !SetupComm( idComDev, 4096, 1024 )) {
			printf( "SetupComm failed.\n" );
			return( 0 );
		} else {
			CommTimeOuts.ReadIntervalTimeout = MAXDWORD;
			CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
			CommTimeOuts.ReadTotalTimeoutConstant = 0;
			CommTimeOuts.WriteTotalTimeoutMultiplier = 2;
			CommTimeOuts.WriteTotalTimeoutConstant = 2000;
			if ( !SetCommTimeouts( idComDev, &CommTimeOuts )) {
				printf( "SetCommTimeouts failed.\n" );
				return( 0 );
			} else {
				printf( "SetCommTimeouts succeeded.\n" );
			}
			return( 1 );
		}
	}
}

__declspec(dllexport) void CommPort_close(struct HCommPort *x)
{
}

__declspec(dllexport) void CommPort_startUp(struct HCommPort *x)
{
	DCB dcb;
	char commStr[50];
	DWORD nWritten;
	if ( GetCommState( idComDev, &dcb )) {
		printf( "GetCommState succeeded\n" );
	} else {
		printf( "GetCommState failed\n" );
	}

	//sprintf( commStr, "%s:%d,%s,%d,%d", port, baud, parity, bits, stopBits );
//	sprintf( commStr, , port );
	if ( BuildCommDCB( "COM2: baud=9600 parity=N data=8 stop=1", &dcb )) {
		printf( "BuildCommDCB succeeded\n" );
	} else {
		printf( "BuildCommDCB failed\n" );
	}

//	if ( err < 0 )
//	{
		//sprintf( errorStr, "Failed BuildCommDCB '%s', error %d", commStr, err );
//		return;
//	}
	if ( SetCommState( idComDev, &dcb )) {
		printf( "SetCommState succeeded\n" );
	} else {
		printf( "SetCommState failed\n" );
	}

//	if ( err < 0 )
	//{
		//sprintf( errorStr, "Failed SetCommState, error %d", err );
		//return;
	//}
	//sprintf ( errorStr, "Successfully started '%s'", commStr );
	//initialized = True;
	nWritten = 0;
	if ( WriteFile( idComDev, "START", 5, &nWritten, NULL )) {
		printf( "WriteFile succeeded, wrote %d bytes\n", nWritten );
	} else {
		printf( "WriteFile failed, error %d\n", GetLastError() );
	}
}

__declspec(dllexport) long CommPort_readByte(struct HCommPort * myPort ) {
	unsigned char data[10];
	int length = 10;
	DWORD iBytesRead;
	BOOL bStat = ReadFile( idComDev, data, length, &iBytesRead, NULL );
	if ( iBytesRead == 0 ) {
		return( -1 );
	}
	if ( bStat ) return( data[0] );
	else return( -1 );
}

__declspec(dllexport) long CommPort_read(struct HCommPort* myPort,HArrayOfByte* bytes, long numberOfBytes)
{
	char* scan;
	DWORD iBytesRead;
	BOOL bStat;
	scan = unhand( bytes );
	bStat = ReadFile( idComDev, scan, numberOfBytes, &iBytesRead, NULL );
	if ( iBytesRead == 0 ) {
		return( -1 );
	}
	return( iBytesRead );
}

